#region Namespaces
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Windows.Media.Imaging;
using Autodesk.Revit.ApplicationServices;
using Autodesk.Revit.Attributes;
using Autodesk.Revit.DB;
using Autodesk.Revit.UI;
#endregion

namespace ManageSheetSpecs
{
    class App : IExternalApplication
    {
        const string _name = "ManageSheetSpecs";
        const string _tooltip_long_description = "Update Sheet Specs from Word Document.";
        static string _text = "Manage Sheet Specs";
        static string _namespace_prefix = typeof(App).Namespace + ".";
        public const string Message = "Update Sheet Specs from Word Document.";

        #region Load bitmap from embedded resources
        /// <summary>
        /// Load a new icon bitmap from embedded resources.
        /// For the BitmapImage, make sure you reference 
        /// WindowsBase and PresentationCore, and import 
        /// the System.Windows.Media.Imaging namespace. 
        /// </summary>
        public static BitmapImage NewBitmapImage(Assembly a, string imageName)
        {
            //Stream s = a.GetManifestResourceStream(_namespace_prefix + imageName);
            Stream s = Assembly.GetExecutingAssembly().GetManifestResourceStream("ManageSheetSpecs." + imageName);
            BitmapImage img = new BitmapImage();

            img.BeginInit();
            img.StreamSource = s;
            img.EndInit();

            return img;
        }
        #endregion // Load bitmap from embedded resources

        public Result OnStartup(UIControlledApplication a)
        {
            string tabName = "Kirksey";
            a.CreateRibbonTab(tabName);

            Assembly exe = Assembly.GetExecutingAssembly();
            string path = exe.Location;
            string className = GetType().FullName.Replace("App", "Command");

            PushButtonData d = new PushButtonData(_name, _text, path, className);
            d.ToolTip = "Export and Update Sheet Specs";
            d.Image = NewBitmapImage(exe, "SheetSpecUpdate16.png");
            d.LargeImage = NewBitmapImage(exe, "SheetSpecUpdate32.png");
            d.LongDescription = _tooltip_long_description;

            RibbonPanel m_projectPanel = a.CreateRibbonPanel(tabName, "Manage Sheet Images");
            List<RibbonItem> projectButtons = new List<RibbonItem>();
            projectButtons.Add(m_projectPanel.AddItem(d));
            
            return Result.Succeeded;
        }

        public Result OnShutdown(UIControlledApplication a)
        {
            return Result.Succeeded;
        }
    }
}
