﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;


namespace ManageSheetSpecs
{
    public partial class Form1 : Form
    {
        string path = "";

        public Form1()
        {
            InitializeComponent();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            path =  getPath();
            exportWordtoPNG(path);
            Close();
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnSelectWord_Click(object sender, EventArgs e)
        {
            var ofd = new OpenFileDialog();
            ofd.Filter = "Word Documents (*.docx)|*.docx|All files (*.*)|*>*";
            ofd.FilterIndex = 1;
            ofd.Multiselect = false;

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                txtWordPath.Text = ofd.FileName;
            }
        }

        public string getPath()
        {
            string path;
            path = txtWordPath.Text;
            return path;
        }

        private void exportWordtoPNG(string path)
        {
            //set resolution for export and empty page size
            int resolution = 150;
            float pWidth = 0.00f;
            float pHeight = 0.00f;

            //Load the document
            WordDocument doc = new WordDocument(path);

            //Get the Document size
            foreach (WSection section in doc.Sections)
            {
                pHeight = (section.PageSetup.PageSize.Height) / 72;
                pWidth = (section.PageSetup.PageSize.Width) / 72;
            }

            //calculate image size for bitmap
            int bitmapWidth = Convert.ToInt32(pWidth * resolution);
            int bitmapHeight = Convert.ToInt32(pHeight * resolution);

            //convert doc to Image
            Image[] images = doc.RenderAsImages(ImageType.Metafile);
            doc.Close();

            int i = 1;

            foreach (Image image in images)
            {
                Bitmap bitmap = null;
                Metafile metafile = image as Metafile;
                bitmap = new Bitmap(bitmapWidth, bitmapHeight);
                bitmap.SetResolution((float)resolution, (float)resolution);
                using (Graphics g = Graphics.FromImage(bitmap))
                {
                    g.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias;
                    g.DrawImage(metafile, 0, 0, (float)bitmapWidth, (float)bitmapHeight);
                    g.Dispose();
                }
                bitmap.Save(@"C:\\ssImages\Sheet Specs" + i.ToString("D3") + ".png", ImageFormat.Png);
                bitmap.Dispose();
                i++;
                bitmap = null;
            }
        }
    }
}
